<?php

require_once('/usr/local/etc/mos/www/modules/proxy/class.php');
//require_once('modules/proxy/class.php');

// constants
define('YF_CK','/tmp/yify.ck');
define('YF_JS_IN','/tmp/js-in.js');
define('YF_JS_OUT','/tmp/js-out.txt');
define('YF_JS_ENGINE','/usr/local/etc/mos/bin/js');
define('YF_UA','Mozilla/5.0 (Windows NT 10.0; WOW64; rv:41.0) Gecko/20100101 Firefox/41.0');

// get config
$yify_config = array (
  'type' => 'files',
  'query' => 'releases',
  'sort' => 'no',
  'order' => 'desc',		// sesc asc
  'p' => '1',			// page
  'quality' => 'lo',
  'keyboard' => 'emb',
  'cast' => 'normal',		// normal | http | proxy
  'user' => '',
  'pass' => '',
);

$yify_config_path = dirname( __FILE__ ) .'/yify.config.php';

if( is_file( $yify_config_path ) )
{
	include( $yify_config_path );
}

// get session categories
$yify_session = array(
	'genres' => array(),
	'langs'  => array(),
);

$yify_session_path = '/tmp/yify.session.php';

if( is_file( $yify_session_path ) )
{
	include( $yify_session_path );
}

// set sorts
$yify_sorts = array(
	'no'    => 'no',
	'title' => 'orderby=title',
	'rating'=> 'meta_key=rating&orderby=meta_value',
	'vote'  => 'meta_key=votes&orderby=meta_value',
	'imdb'  => 'meta_key=imdbRating&orderby=meta_value',
);

//
// ====================================
function curl_ssl_ok()
{
    if (function_exists('curl_version')) {
		$v = curl_version(); 
		if (strlen($v['ssl_version']) > 1) 
		  return true;
		else 
		  return false;       
	}
		else 
		  return false;
}
//
// ====================================
function rss_yify_content()
{
	include('yify.rss.main.php');

	$view = new rssYifyView;
	$view->showRss();
}
//
// ====================================
function str_between($start, $end, $string){ 
	$string = " ".$string; $ini = mb_strpos($string, $start); 
	if ($ini == 0) return ""; $ini += mb_strlen($start); $len = mb_strpos($string,$end,$ini) - $ini; 
	return mb_substr($string,$ini,$len); 
}
//
// ====================================
function getInbetweenStrings($start, $end, $str){
    $matches = array();
    $regex = "/$start([a-zA-Z0-9_]*)$end/";
    preg_match_all($regex, $str, $matches);
    return $matches[1];
}

//
// ------------------------------------
function getYifyConfigParameter( $name )
{
global $yify_config;

	return $yify_config[ $name ];
}
//
// ------------------------------------
function saveYifyConfig()
{
global $yify_config;
global $yify_config_path;

if( isset( $_REQUEST['debug'] ))
{
	echo "saveYifyConfig\n";
	print_r( $yify_config );
}

	file_put_contents( $yify_config_path, '<?php $yify_config = '.var_export( $yify_config, true ).'; ?>' );
}
//
// ------------------------------------
function saveYifySession()
{
global $yify_session;
global $yify_session_path;

if( isset( $_REQUEST['debug'] ))
{
	echo "saveYifySession\n";
	print_r( $yify_session );
}

	file_put_contents( $yify_session_path, '<?php $yify_session = '.var_export( $yify_session, true ).'; ?>' );
}
//
// ------------------------------------
function loginYify( $un, $pw ) 
{
	
	if ( curl_ssl_ok() ) { 
	
		$c = curl_init('http://yify.tv/');
		curl_setopt($c, CURLOPT_USERAGENT, YF_UA);
		curl_setopt($c, CURLOPT_POST, 1);
		curl_setopt($c, CURLOPT_POSTFIELDS, 'log=' . $un . '&pwd=' . $pw . '&rememberme=forever&a=login&ajax=1&redirect_to=http%3A%2F%2Fyify.tv%2F');
		curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
//  	curl_setopt($c, CURLOPT_COOKIEFILE, YF_CK);
		curl_setopt($c, CURLOPT_COOKIEJAR, YF_CK);
		curl_setopt($c, CURLOPT_COOKIESESSION, true);
		$s = curl_exec($c);
		curl_close($c);
		
	} else $s = file_get_contents('http://yify.tv/' );
		
	return $s;
}

//
// ------------------------------------
function getYifyContent($url, $pf=0, $xr=0)
{
	 
	if ( curl_ssl_ok() ) {  

		$c = curl_init($url);
		if (strlen($pf) > 2){
			curl_setopt($c, CURLOPT_POST, 1);
			curl_setopt($c, CURLOPT_POSTFIELDS,	$pf);
		}
		curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
		if ($xr != 0) curl_setopt($c, CURLOPT_HTTPHEADER, array("X-Requested-With: XMLHttpRequest"));
		//curl_setopt($c, CURLOPT_REFERER, '');
		curl_setopt($c, CURLOPT_USERAGENT, YF_UA);
		curl_setopt($c, CURLOPT_COOKIESESSION, true);
		curl_setopt($c, CURLOPT_COOKIEJAR, YF_CK);	
		curl_setopt($c, CURLOPT_COOKIEFILE, YF_CK);
		if( isset( $_REQUEST['debug'] ))
		{
			curl_setopt($c, CURLOPT_HEADER, 1);
			curl_setopt($c, CURLINFO_HEADER_OUT, true);
			curl_setopt($c, CURLOPT_VERBOSE, 1);
		}
		$s = curl_exec($c);
		if( isset( $_REQUEST['debug'] )) print_r(curl_getinfo($c));
		curl_close($c);
		
	} else $s = file_get_contents( $url ); 
	
	return $s;
}

// ------------------------------------
function getLoginStatus()
{
	global $yify_config;
		
	if ( curl_ssl_ok() ) { 
	
		$out = ' [ - ] ';
		if (strlen($yify_config['user']) > 2) {
			if( is_file( YF_CK ) ) {
				$out = @file_get_contents( YF_CK );
				if (strpos($out , $yify_config['user']) > 0) 
					$out = ' [ ' . $yify_config['user'] . ' ] ' ;
			}
		}
		
	} else $out = ' * ';
		
	return $out;
}

//
// ------------------------------------

function getYifyVideo( $id, $mr=0 )
{

global $yify_config;

	$s = getYifyContent( 'http://yify.tv/'. $id .'/');
	$player = str_between('<param name="movie" value="','"' , $s);
	$a= str_between('fofofo(){};','</script>', $s);
	$a= 'function fofofo(){}; '.$a;
//	$a= "function".str_between('function','function on_L', $a);
    $a= preg_replace('/\(function.*\(\);/', '', $a);
    $a= "$a \nprint(parametros);";
	
	file_put_contents(YF_JS_IN, $a);
	if( isset( $_REQUEST['debug'] )) echo "JS Input 1: ".$a;
	exec(YF_JS_ENGINE.' '.YF_JS_IN.' > '.YF_JS_OUT);
	$a = file_get_contents(YF_JS_OUT);
	
	$a = substr($a, 1); // remove ?
	$videoIds = explode("&", $a);
	$videoIx = explode("=", $videoIds[intval($mr)]);
	$videoId = $videoIx[1];
	$videoTy = $videoIx[0];

	getYifyContent("http://yify.tv".$player);

	//$s = getYifyContent( 'http://yify.tv/player/pk/pk/plugins/player_p2.php', 'fv=19&url='.$videoId.'&sou='.$videoTy, 1);
	  $s = getYifyContent( 'http://yify.tv/playerlite/pk/pk/plugins/player_p2.php', 'url='.$videoId.'&sou='.$videoTy, 1);
	
	
	$a=json_decode($s, true);
	
	if ((is_array($a[0])) && array_key_exists('jscode', $a[0])){
	
		$a=substr($a[0]["jscode"],13,-2);
		$a=str_replace("parseRes2", "print", $a);
			
		file_put_contents(YF_JS_IN, $a);
		if( isset( $_REQUEST['debug'] )) echo "JS Input 2: ".$a;
		exec(YF_JS_ENGINE.' '.YF_JS_IN.' > '.YF_JS_OUT);
		$a = file_get_contents(YF_JS_OUT);
	
		$a=json_decode($a, true);
    }
	
	$minStream = 0;
	$maxStream = 0;

	$mi = 100500;
	$ma = 0;

	if (is_array($a))
	{
		foreach( $a as $i => $st )
		{
			if( $st['type'] != 'video/mpeg4' &&
				$st['type'] != 'application/x-shockwave-flash' ) continue;

			if( $st['height'] < $mi )
			{
				$mi = $st['height'];
				$minStream = $i;
			}

			if( $st['height'] > $ma )
			{
				$ma = $st['height'];
				$maxStream = $i;
			}
		}
	}
	
	if (($a[ $maxStream ]['url']) || ($a[ $minStream ]['url'])){
	
		if( $yify_config['quality'] == 'hi' ) $oul = $a[ $maxStream ]['url'];
			else $oul = $a[ $minStream ]['url'];
	
	} else { // other source
		$oul = 'Err';
		if( $yify_config['quality'] == 'hi' ) $oul = str_between('22|', ',', urldecode($s));
		 else $oul = str_between('18|', ',', urldecode($s));
		if (strlen($oul) < 4) $oul = str_between('|', ',', urldecode($s));
	}
	
	if( isset( $_REQUEST['debug'] )) echo "Link: ".$oul; 
	
	return $oul;
}
//
// ------------------------------------
function yify_get_content()
{
global $mos;
global $yify_config;

	header( "Content-type: text/plain" );

	if( ! isset( $_REQUEST['id'])) return;
	if(isset( $_REQUEST['mr'])) $mr = $_REQUEST['mr'];
	 else $mr = 0;
	$id = $_REQUEST['id'];
	$u = getYifyVideo( $id, $mr );
	if( $u == '' ) return;

	if( $yify_config['cast'] == 'proxy' )
	{
		proxy::setUrl( $u );
		$u = proxy::getUrl();
	}
	elseif( $yify_config['cast'] == 'http' )
	{
		$u = str_replace( 'https://', 'http://', $u ); // quick fix https
		$u = str_replace( ':443', '', $u );
	}

	echo $u;
}
//
// ------------------------------------
function yify_savelogin_content()
{
global $yify_config;
    
	if(  isset( $_REQUEST['out'])) {
		$yify_config['user'] = '';
		$yify_config['pass'] = '';
	} else {
		$yify_config['user'] = $_REQUEST['login'];
		$yify_config['pass'] = $_REQUEST['passwd'];
	}
	
	// save config
	saveYifyConfig();
	
	// erase cookies
	unlink(YF_CK);
	
	// refresh
	yify_list_content();

}
//
// ====================================
function getYifyRequest( $name )
{
global $yify_config;

	$s = $yify_config[ $name ];
	if( isset( $_REQUEST[ $name ] ))
	{
		$s = $_REQUEST[ $name ];
	}
	$yify_config[ $name ] = $s;
	return $s;
}
//
// ------------------------------------
function replaceHtmlEntity( $s )
{
	$s = str_replace( '&#8230;', '...', $s );
	$s = str_replace( '&#8217;', "'", $s );
	$s = str_replace( '&#8220;', '"', $s );
	$s = str_replace( '&#8221;', '"', $s );

	return $s;
}
//
// ------------------------------------
function yify_list_content()
{
global $yify_config;
global $yify_session;
global $yify_sorts;

header( "Content-type: text/plain" );

	$url = 'http://yify.tv/';
	$pars = array();

	// settings
	$quality  = getYifyRequest('quality');
	$keyboard = getYifyRequest('keyboard');
	$cast     = getYifyRequest('cast');

	// query
	$query = getYifyRequest('query');

	$type = getYifyRequest('type');
	if ( $type == '' )
	{
		$type = 'files';
		$query = 'movies';
		$yify_config['type' ] = 'files';
		$yify_config['query'] = 'movies';
	}

	if    ( $type == 'search'  ) $pars[] = 's='. $query;
	else $url .= $type .'/'. $query .'/';

	$page = getYifyRequest('p');
	if( $page != 1 ) $url .= 'page/'. $page .'/';

	$sort = getYifyRequest('sort');
	$pars[] = $yify_sorts[ $sort ];

	$order = getYifyRequest('order');
	$pars[] = 'order='. $order;

	$url .= '?'. implode( '&', $pars );

	// save config
	saveYifyConfig();


if( isset( $_REQUEST['debug'])) echo "url=$url\n";

	// do login
	if( !is_file( YF_CK ) )
	{
		if (strlen($yify_config['user']) > 1) $s = loginYify($yify_config['user'],$yify_config['pass']);
		else file_put_contents( YF_CK, '#nothing');
	}
	
	// get html page
	$s = getYifyContent( $url );

//if( isset( $_REQUEST['debug'])) echo "$s\n";

	// get genres
	if( preg_match( '/<select.*?id="genre"(.*?)select>/s', $s, $ss ) > 0 )
	 if( preg_match_all( '/value="([^"]*?)">(.*?)</s', $ss[1], $ss ) > 0 )
	 {
		$yify_session['genres'] = array();

		foreach( $ss[1] as $i => $id )
		 $yify_session['genres'][ $id ] = $ss[2][ $i ];

		saveYifySession();
	}

	// get items
	$items = array();

	if( preg_match( '|var posts = (\{.*?\});|s', $s, $a ) > 0 )
	{
		$a = json_decode( $a[1], true );

		foreach( $a['posts'] as $item )
		{
			// url, image
			$id  = str_replace( array( 'http://yify.tv/', '/' ), '', $item['link'] );
			$img = str_replace( 'https://', 'http://', $item['image'] );

			// title
			$title = replaceHtmlEntity( trim( $item['title'] ));

			// year
			$title .= ' ('. $item['year'] .')';

			// desc
			$desc = replaceHtmlEntity( trim( $item['post_content'] ));

			// genres
			$genre = trim( $item['genre'] );

			$items[] = array(
				'id'   => $id,
				'title'=> $title,
				'image'=> $img,
				'desc' => $desc,
				'genre'=> $genre,
			);
		}
	}

if( isset( $_REQUEST['debug'])) print_r( $items );

	// get navigation
	$pmax = $page;
	if( preg_match( '|<div class="contenedor_page container col-md-8">(.*?)</div>|s', $s, $a ) > 0 )
	 if( preg_match_all( '|/page/(.*?)/|s', $a[1], $ss ) > 0 )
	  foreach( $ss[1] as $m )
	   if( $pmax < $m ) $pmax = $m;

if( isset( $_REQUEST['debug'])) echo "Max page=$pmax\n";

	// generate list
	$s = '';

	// top title
	$s .= 'yify.tv';

	if    ( $type == 'search' )	$s .= ' - '. urldecode( $query );
	elseif( $type == 'genre' )	$s .= ' - '. $yify_session['genres'][ $query ];
	elseif( $type == 'languages' )	$s .= ' - '. $yify_session['langs'][ $query ];
	else				$s .= ' - '. getMsg( 'yify_title_'. $query );
	$s .= PHP_EOL ;

	// bottom title
	$s .=
		'<< ' . getMsg('coreRssPromptMenu') .
		getRssCommandPrompt('enter')  . getMsg('coreRssPromptWatch') .
		getLoginStatus() .PHP_EOL;

	// sort
	if( $sort != 'no' ) $s .= getMsg( 'yify_sort_'. $sort ) .', ';
	$s .= getMsg( 'yify_sort_'. $order ) .PHP_EOL ;

	// page
	if( $pmax > 1 ) $s .= $page .'/'. $pmax;
	$s .= PHP_EOL ;

	// navs
	$url = getMosUrl().'?page=yify_list';
	if( $page != 1 ) $s .= $url.'&p='. ( $page - 1 );
	$s .= PHP_EOL;

	if( $page != $pmax ) $s .= $url.'&p='. ( $page + 1 );
	$s .= PHP_EOL;
	
	// number of items
	$s .= count( $items ) . PHP_EOL;

	foreach( $items as $item )
	{
		$s .= $item['id']   .PHP_EOL;
		$s .= $item['title'].PHP_EOL;
		$s .= $item['image'].PHP_EOL;
		$s .= $item['desc'] .PHP_EOL;
		$s .= $item['genre'].PHP_EOL;
	}

	if( isset( $_REQUEST['debug']))
	{
		echo $s;
	}
	else
	{
		file_put_contents( '/tmp/put.dat', $s );
		echo "/tmp/put.dat";
	}
}
//
// ====================================
function rss_yify_menu_content()
{
global $yify_config;

	include( 'yify.rss.menu.php' );
	$view = new rssYifyLeftView;

	$view->items = array();

	$i = 0;
	$cur = -1;

	$type  = $yify_config['type'];
	$query = $yify_config['query'];

	if( $type == 'files' && $query == 'movies') $cur = $i;
	$view->items[ $i++ ] = array(
		'title'	=> getMsg('yify_title_movies'),
		'action'=> 'ret',
		'link'	=> getMosUrl().'?page=yify_list&amp;type=files&amp;query=movies&amp;p=1'
	);

	if( $type == 'files' && $query == 'releases') $cur = $i;
	$view->items[ $i++ ] = array(
		'title'	=> getMsg('yify_title_releases'),
		'action'=> 'ret',
		'link'	=> getMosUrl().'?page=yify_list&amp;type=files&amp;query=releases&amp;p=1'
	);

	if( $type == 'genres') $cur = $i;
	$view->items[ $i++ ] = array(
		'title'	=> getMsg('yify_title_genre'),
		'action'=> 'rss',
		'link'	=> getMosUrl().'?page=rss_yify_genres'
	);

	if( $type == 'languages') $cur = $i;
	$view->items[ $i++ ] = array(
		'title'	=> getMsg('yify_title_langs'),
		'action'=> 'rss',
		'link'	=> getMosUrl().'?page=rss_yify_langs'
	);

	if( $type == 'search') $cur = $i;
	$view->items[ $i++ ] = array(
		'title'	=> getMsg('yify_title_search'),
		'action'=> 'search',
		'link'	=> getMosUrl().'?page=yify_list&amp;type=search&amp;p=1&amp;query='
	);

	$view->items[ $i++ ] = array(
		'title'	=> getMsg('yify_title_sort'),
		'action'=> 'rss',
		'link'	=> getMosUrl().'?page=rss_yify_sort',
		'border' => 'top',
	);

	$view->items[ $i++ ] = array(
		'title'	=> getMsg('yify_title_sets'),
		'action'=> 'rss',
		'link'	=> getMosUrl().'?page=rss_yify_sets',
	);
	
	$view->items[ $i++ ] = array(
		'title'	=> getMsg( 'yifyEntry'),
		'action'=> 'rss',
		'link'	=> getMosUrl().'?page=rss_yify_login',
		'border' => 'top',
	);

	if( $cur == -1) $cur = 0;
	$view->currentItem = $cur;

	$view->showRss();
}
//
// ====================================
function rss_yify_genres_content()
{
global $yify_config;
global $yify_session;

	include( 'yify.rss.menu.php' );
	$view = new rssYifyLeftView;

	$view->position = 1;

	$view->items = array();

	$i = 0;
	foreach( $yify_session['genres'] as $id => $item )
	{
		if( $id == $yify_config['query'] ) $view->currentItem = $i;
		$view->items[ $i++ ] = array(
			'title'	=> $item,
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=yify_list&amp;p=1&amp;type=genre&amp;query='. $id
		);
	}

	$view->showRss();
}
//
// ====================================
function rss_yify_langs_content()
{
global $yify_config;
global $yify_session;

	if( count( $yify_session['langs'] ) == 0 )
	{
		// get langs
		$s = getYifyContent( 'http://yify.tv/languages/' );

		if( preg_match_all( '|<td><a href="/languages/(.*?)/">(.*?)</a></td>|s', $s, $a ) > 0 )
		{
			$yify_session['langs'] = array();

			foreach( $a[1] as $i => $id )
			 $yify_session['langs'][ $id ] = $a[2][ $i ];

			saveYifySession();
		}
	}

	include( 'yify.rss.menu.php' );
	$view = new rssYifyLeftView;

	$view->position = 1;

	$view->items = array();

	$i = 0;
	foreach( $yify_session['langs'] as $id => $item )
	{
		if( $id == $yify_config['query'] ) $view->currentItem = $i;
		$view->items[ $i++ ] = array(
			'title'	=> $item,
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=yify_list&amp;p=1&amp;type=languages&amp;query='. $id
		);
	}

	$view->showRss();
}
//
// ====================================
function rss_yify_sort_content()
{
global $yify_config;
global $yify_sorts;

	include( 'yify.rss.menu.php' );
	$view = new rssYifyLeftView;

	$view->position = 1;

	$view->items = array();

	$i = 0;
	foreach( $yify_sorts as $id => $item )
	{
		if( $id == $yify_config['sort'] ) $view->currentItem = $i;

		$view->items[ $i++ ] = array(
			'title'	=> getMsg('yify_sort_'. $id ),
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=yify_list&amp;p=1&amp;sort='. $id
		);
	}

	if( $yify_config['order'] == 'desc' )
	 $view->items[ $i++ ] = array(
		'title'	=> getMsg('yify_sort_asc' ),
		'action'=> 'ret',
		'link'	=> getMosUrl().'?page=yify_list&amp;p=1&amp;order=asc',
		'border' => 'top',
	 );
	else
	 $view->items[ $i++ ] = array(
		'title'	=> getMsg('yify_sort_desc' ),
		'action'=> 'ret',
		'link'	=> getMosUrl().'?page=yify_list&amp;p=1&amp;order=desc',
		'border' => 'top',
	 );

	$view->showRss();
}
//
// ====================================
function rss_yify_sets_content()
{
	include( 'yify.rss.menu.php' );
	$view = new rssYifyLeftView;

	$view->position = 1;

	$view->items = array(
		array(
			'title'	=> getMsg('yifyQuality'),
			'action'=> 'rss',
			'link'	=> getMosUrl().'?page=rss_yify_quality'
		),
		array(
			'title'	=> getMsg('yifyKeyboard'),
			'action'=> 'rss',
			'link'	=> getMosUrl().'?page=rss_yify_keyboard'
		),
		array(
			'title'	=> getMsg('yifyCast'),
			'action'=> 'rss',
			'link'	=> getMosUrl().'?page=rss_yify_cast'
		),
	);

	$view->showRss();
}
//
// ------------------------------------
function rss_yify_quality_content()
{
global $yify_config;

	include( 'yify.rss.menu.php' );
	$view = new rssYifyLeftView;

	$view->position = 2;

	$view->items = array(
		array(
			'title'	=> getMsg('yifyLowQual'),
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=yify_list&amp;quality=lo'
		),
		array(
			'title'	=> getMsg('yifyHighQual'),
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=yify_list&amp;quality=hi'
		),
	);

	$view->currentItem = 0;
	if( $yify_config['quality'] == 'hi'  ) $view->currentItem = 1;

	$view->showRss();
}
//
// ------------------------------------
function rss_yify_keyboard_content()
{
global $yify_config;

	include( 'yify.rss.menu.php' );
	$view = new rssYifyLeftView;

	$view->position = 2;

	$view->items = array(
		array(
			'title'	=> getMsg('yifyEmbKbrd'),
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=yify_list&amp;keyboard=emb'
		),
		array(
			'title'	=> getMsg('yifyRssKbrd'),
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=yify_list&amp;keyboard=rss'
		),
	);

	$view->currentItem = 0;
	if( $yify_config['keyboard'] == 'rss' ) $view->currentItem = 1;

	$view->showRss();
}
//
// ------------------------------------
function rss_yify_cast_content()
{
global $yify_config;

	include( 'yify.rss.menu.php' );
	$view = new rssYifyLeftView;

	$view->position = 2;

	$view->items = array(
		array(
			'title'	=> getMsg('yifyCastNormal'),
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=yify_list&amp;cast=normal'
		),
		array(
			'title'	=> getMsg('yifyCastHttp'),
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=yify_list&amp;cast=http'
		),
		array(
			'title'	=> getMsg('yifyCastProxy'),
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=yify_list&amp;cast=proxy'
		),
	);

	if(     $yify_config['cast'] == 'http'  ) $view->currentItem = 1;
	elseif( $yify_config['cast'] == 'proxy' ) $view->currentItem = 2;
	else $view->currentItem = 0;

	$view->showRss();
}
//
// ------------------------------------
function rss_yify_pop_content()
{
	include( 'modules/core/rss_view_popup.php' );
	$view = new rssSkinPopupView;
	$view->topTitle = getMsg('yify_mr');

	$view->items = array();

	for ($i = 0; $i < 10; $i++)
	{
		$view->items[ $i ] = array(
			'title'	=> getMsg('yify_mr'). ' ' .($i + 1),
			'action'=> 'ret',
			'link'	=> $i
		);
	}
	
	$view->currentItem = 0;
	$view->showRss();
}
//
// ------------------------------------
function rss_yify_login_content()
{
global $yify_config;

	include( 'login_view.php' );
	
	class rssLoginView extends rssSkinLoginView
	{
		//
		// ------------------------------------
		public function showItemDisplay()
		{

?>
    <itemDisplay>
      <script>
	idx = getQueryItemIndex();
	drawState = getDrawingItemState();
	if (drawState == "unfocus")
	{
		bcolor = "<?= static::itemBackgroundColor ?>";
		fcolor = "<?= static::unFocusFontColor ?>";
	}
	else
	{
		bcolor = "<?= static::itemFocusBgColor ?>";
		fcolor = "<?= static::focusFontColor ?>";
	}
      </script>
<?php
			$px = round( static::itemTextX / static::itemWidth  * 100, 4);
			$py = round( static::itemTextY / static::itemHeight * 100, 4);
			$pw = round( static::itemTextWidth  / static::itemWidth  * 100, 4);
			$ph = round( static::itemTextHeight / static::itemHeight * 100, 4);

?>
      <text offsetXPC="<?= $px ?>" offsetYPC="<?= $py ?>" widthPC="<?= $pw ?>" heightPC="<?= $ph ?>" 
       align="<?= static::itemTextAlign ?>" lines="<?= static::itemTextLines ?>" fontSize="<?= static::itemTextFontSize ?>" >
	<backgroundColor><script>bcolor;</script></backgroundColor>
	<foregroundColor><script>fcolor;</script></foregroundColor>
	<script>
	if( idx == 0 ) login;
	else if( idx == 1 )
	{
		if( passwd == "" ) "";
		else "****";
	}
	else if( idx == 2 ) "<?= getMsg( 'yifyEntry' ) ?>";
	else if( idx == 3 ) "<?= getMsg( 'yifyOut' ) ?>";
	else null;
	</script>
      </text>
    </itemDisplay>
<?php
		}
	//
	// ------------------------------------
	function showOnUserInput()
	{
?>
    <onUserInput>
	ret = "false";
	input = currentUserInput();
	if (input == "<?= getRssCommand('enter') ?>"  || input == "<?= getRssCommand('right') ?>")
	{
		idx = getFocusItemIndex();
		if( idx == 0 )
		{
<?php
		if( getYifyConfigParameter( 'keyboard' ) == 'rss' )
		{
?>
			str = doModalRss("<?= getMosUrl().'?page=rss_keyboard' ?>");
<?php
		}
		else
		{
?>
			str = getInput("<?= getMsg( 'yifyLogin' ) ?>");
<?php
		}
?>
			if(( str != null )&amp;&amp;( str != "" ))
			{
				login = str;
				redrawDisplay();
			}
		}
		else if( idx == 1 )
		{
<?php
		if( getYifyConfigParameter( 'keyboard' ) == 'rss' )
		{
?>
			str = doModalRss("<?= getMosUrl().'?page=rss_keyboard' ?>");
<?php
		}
		else
		{
?>
			str = getInput("<?= getMsg( 'yifyPasswd' ) ?>");
<?php
		}
?>
			if(( str != null )&amp;&amp;( str != "" ))
			{
				passwd = str;
				redrawDisplay();
			}
		}
		else if( idx == 2 )
		{
			url = "<?= getMosUrl().'?page=yify_savelogin' ?>"
			 + "&amp;login=" + urlEncode( login )
			 + "&amp;passwd=" + urlEncode( passwd );

			setReturnString( url );
			postMessage( "<?= getRssCommand('return') ?>" );
		}
		else if( idx == 3 )
		{
			url = "<?= getMosUrl().'?page=yify_savelogin' ?>"
			 + "&amp;out=1";
			
			setReturnString( url );
			postMessage( "<?= getRssCommand('return') ?>" );
		}
		ret = "true";
	}
	else if (input == "<?= getRssCommand('left') ?>" )
	{
		ret = "true";
	}
	ret;
    </onUserInput>
<?php
		}
		//
		// ------------------------------------

		public $login;
		public $passwd;

		//
		// ------------------------------------
		public function showScripts()
		{
?>
  <onEnter>
<?php
	if( getMosOption('sdk_version') > 3 )
	{

?>
	setParentFade(96);
<?php
	}

?>

	login  = "<?= $this->login ?>";
	passwd = "<?= $this->passwd ?>";
  </onEnter>
<?php
		}
		//
		// ------------------------------------
		public function showChannel()
		{
?>
  <channel>
    <itemSize>
      <script>
	4;
      </script>
    </itemSize>
  </channel>
<?php
		}
	}

	$view = new rssLoginView;

	$view->topTitle = 'Login';

	$view->login  = $yify_config['user'];
	$view->passwd = $yify_config['pass'];

	$view->infos[] = array(
		'type' => 'text',
		'posX' => 50,
		'posY' => 50,
		'width'  => 150,
		'height' => 40,
		'text' => getMsg( 'yifyLogin' )
	);

	$view->infos[] = array(
		'type' => 'text',
		'posX' => 50,
		'posY' => 90,
		'width'  => 150,
		'height' => 40,
		'text' => getMsg( 'yifyPasswd' )
	);

	$view->items = array(0,1,2,3);

	$view->showRss();
}

//To test direct call (debug)
//echo getYifyVideo( 'watch-bare-online-free-yify' , <mirror -1>);

//echo getYifyVideo( 'watch-bare-online-free-yify' , 0);
?>